''***************************************
''*  z8Busdrive v2.2  Objekt CALC       *
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2011 by UN-Soft      *
''*  See end of file for terms of use.  *
''***************************************

' 

OBJ
    def          : "tiny_4k_def"    

PUB start (ram_adr,rom_adr,bmp_adr,col_adr,regxadr)

     ram_base    := ram_adr
     rom_base    := rom_adr   
     bmp_buff    := bmp_adr
     col_buff    := col_adr
     calc_cmd_adr:= regxadr + def#calccmdreg   'phys. Adresse des Registers zur bergabe CMD
     cognew(@CALC,ram_adr)                     'Berechnung-Cog starten
               

DAT 'Berechnung- Cog
org 0
'******************************************************************************************************
'---- Mainloop ----------------------------------------------------------------------------------------
'******************************************************************************************************                  
CALC              mov Mem, par
                  mov temp2, std_col
                  call #col_set                   'und setzen
                  mov calc_dat_adr, calc_cmd_adr
                  add calc_dat_adr, #1
                  mov scr_buff, bws_start
                  sub scr_buff, ram_s
                  add scr_buff, ram_base

Cmd_start         rdbyte cmdnr, calc_cmd_adr       'einlesen Kommando aus bergabezelle nach <cmdnr>
                  rdbyte calcdat,calc_dat_adr      'einlesen Datenbyte aus bergabezelle nach <calcdat>
                  cmp cmdnr, #$00          wz      '
         if_z     jmp #bws
                  cmp cmdnr, #$21          wz
         if_z     jmp #set_col
{              
                  cmp cmdnr, #$22          wz
         if_z     jmp #set_moni
                  cmp cmdnr, #$24          wz
         if_z     jmp #clear_bmp
                  cmp cmdnr, #$25          wz
         if_z     jmp #set_bmp
}         
{                  cmp cmdnr, #$2F          wz
         if_z     jmp #blink_ok
                  cmp cmdnr, #$2E          wz
         if_z     jmp #blink_err
}
                  jmp #Cmd_start
'--------------------------------------------------------------------------------------------------------
     

              
'********************************************************************************************************
'---- Common Parts Mainloop -----------------------------------------------------------------------------
'********************************************************************************************************
bws               call #bws2bmp
                  jmp #Cmd_start 

Cmdx              mov cmdnr, #$00                     'Cmd mit 00 beschreiben -> ready
                  wrbyte cmdnr, calc_cmd_adr                             
                  jmp #Cmd_start

'********************************************************************************************************  
'---- Subroutinen Monitor -------------------------------------------------------------------------------
'********************************************************************************************************
{
                
'......... Monitor-Blink - Fehlermeldung...............................................................                   
blink_ok          mov delay_cnt, delay_cnt_ok
                  mov x3, ok_col
                  mov x1, #3
                  jmp #blink
                       
blink_err         mov delay_cnt, delay_cnt_err
                  mov x3, err_col
                  mov x1, #2
                   
blink             mov temp2, x3
                  call #col_delay_xx
                  call #col_delay_0
                  djnz x1, #blink

                  jmp #Cmdx 
}
{                  
'------------------------------------------------------------------------------------------------------  
clear_bmp         mov temp2, #0     
                  call #bmp_set
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
set_moni          add calcdat, reg0_adr 
                  rdlong vgamode, calcdat           'Ausgabemodus einlesen (4 Bytes)
                  test vgamode, #$08       wz       'Bit 3 testen, ob Cls
         if_nz    jmp #clear_bmp                    'sonst Bitmappuffer lschen
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
set_bmp           add calcdat, reg0_adr 
                  rdlong temp2, calcdat             'auszugebenden Wert einlesen
                  call #bmp_set                     'und nach Bitmappuffer schreiben
                  jmp #Cmdx                         'und zurck
}                  
'------------------------------------------------------------------------------------------------------ 
set_col           add calcdat, reg0_adr 
                  rdlong temp2, calcdat
                  call #col_set
                  jmp #Cmdx

'------------------------------------------------------------------------------------------------------
'-------- Berechnung fr 160 x 240 Pixel --------------------------------------------------------------
'------------------------------------------------------------------------------------------------------
bws2bmp           mov xorx, #$00
                  mov bmp_ptr, bmp_buff             'Adresse Bitmapspeichr nach Pointer  
                  mov scr_ptr, scr_buff             'Adresse TINY -BWS nach Pointer
               
                  test vgamode, #1         wz       'Zeile 0 anzeigen?
   if_z           add scr_ptr, #$20                 'Ja, dann Bilschirmpointer neu berechnen
                  test vgamode, #$4         wz      'Test vgamode auf invertieren
   if_z           mov xorx, xorx_mask
    
                  mov x4, #60                       'Zeilenzahl Grafikspeicher TINY
                  
Zeile_rd          mov bmp_ptrtemp, bmp_ptr      
                  mov scr_ptrtemp, scr_ptr

                  add bmp_ptrtemp,#3                'links 3 Bytes - linker Rand    
                  mov x1, #8                        'Bytezahl graf. BWS TINY pro Zeile = 8 Bytes
                  
:mx               rdbyte temp2, scr_ptrtemp         'read BWS -> temp2
                  shl temp2, #24
                  mov temp3, #8                     'Reihenfolge Bits vertauschen
:xx               shl temp2, #1    wc
                  rcr temp , #1
                  rcr temp , #1        
                  djnz temp3, #:xx
                  shr temp, #16
                  xor temp, xorx
         
:zy               wrword temp, bmp_ptrtemp         'Byte nach Bitmappuffer schreiben  
      
                  add bmp_ptrtemp, #2              'Bitmappointer auf nchstes Word    
                  add scr_ptrtemp, #1              'BWS-Pointer auf nchstes Byte 
                  djnz x1, #:mx                    'zurck bis Zeilenende
              
                  add bmp_ptr, #20                 'nchster Zeilenanfang im Bitmappuffer (160 Pixel=20x8 bit)
                  add scr_ptr, #8 
                  djnz x4, #Zeile_rd               'nchste Zeile im Grafikspeicher TINY, 
 
 
bws2bmp_ret       ret         
                  
'-------------------------------------------------------------------------------------------------------
'---- Common -Parts  -----------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
{bmp_set           mov len_ptr, len_bmp              'Lnge Bitmap-Puffer nach Pointer
                  mov scr_ptr, bmp_buff             'Adresse Bitmap-Puffer nach Pointer
                  jmp #fill_block 
}
{
col_delay_0       mov temp2, std_col
col_delay_xx      mov temp, cnt
                  add temp, delay_cnt 
                  waitcnt temp, #0
}
col_set           mov temp3, temp2                 'Verdopplung word --> long
                  shl temp3, #16
                  or  temp2, temp3 
                  mov len_ptr, len_col             'Lnge Farbspeicher
                  shr len_ptr, #1                  'Umrechnen auf Long
                  mov scr_ptr, col_buff            'Adresse Farbspeicher
fill_block        wrlong temp2, scr_ptr             'Bitmappufferadresse bescheiben 
                  add scr_ptr, #4                   'nchste Long-Adresse
                  djnz len_ptr, #fill_block         'zurck, wenn Lnge grer 0
'bmp_set_ret
fill_block_ret
col_delay_0_ret
col_delay_xx_ret
col_set_ret       ret                               'und zurck
                   
'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************                    
    
 ram_base      long  0
 rom_base      long  0  
 bmp_buff      long  0
 col_buff      long  0 
 len           long  def#lenx  
 len_bmp       long  def#lenbmp 
 len_col       long  def#lencol    '
 vgamode       long  def#stdmodus  
 std_col       long  def#stdcol
' ok_col        long  def#okcol
' err_col       long  def#errcol
 calc_cmd_reg  long  def#calccmdreg
 calc_cmd_adr  long  0                             
 reg0_adr      long  0
 delay_cnt_ok  long  10_000_000
 delay_cnt_err long  50_000_000

 xorx_mask     long  $FFFF

 ram_s         long  def#ramstart        

 bws_start     long  def#bwsstart 

Mem            res   1 
'z8bus_adr      res   1
'z8bus          res   1
scr_buff       res   1
'calc_cmd_adr   res   1
calc_dat_adr   res   1
calcdat        res   1

'vgamode        res   1
cmdnr          res   1 
temp           res   1
temp2          res   1
temp3          res   1
ptr            res   1
x1             res   1
x2             res   1   
x3             res   1
x4             res   1 
scr_ptr        res   1
scr_end        res   1 
bmp_ptr        res   1
len_ptr        res   1
bmp_ptrtemp    res   1
scr_ptrtemp    res   1
xorx           res   1
'delay_cnt      res   1