''***************************************
''*  z8-Emulator  Objekt I/O & Interrupt*
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2012 by UN-Soft      *
''*  See end of file for terms of use.  *
''***************************************

' 

VAR   
   ' long  cog
OBJ
    def           : "tiny_4k_def"    

PUB start (z8reg,ROMx,z8bus,comptr)

 z8reg_adr := z8reg    'Basis-Adresse Register im HUB-Ram
 z8bus_adr := z8bus
' ROM_adr   := ROMx
 
 RxPtr     := comptr
 'TxPtr     := comptr + 4
      
     '' Stop driver - frees a cog
'     if cog
'       cogstop(cog~ -  1)
     
' long[z8bus_adr] :=  %10000000_00000000_00000000_00000000     'Reset_test
      cognew(@main,z8reg)                                       'IO-Cog starten
               

DAT 'Berechnung- Cog
org 0
'******************************************************************************************************
'---- Mainloop ----------------------------------------------------------------------------------------
'******************************************************************************************************                  
main              mov Mem, par
                  mov TxPtr, RxPtr
                  add TxPtr, #4
                 
'......Portregister 00-03...............................
                  add R0_adr, z8reg_adr
                  add R1_adr, z8reg_adr
                  add R2_adr, z8reg_adr
                  add R3_adr, z8reg_adr
'......Systemregister F0 - FB...........................
                  add SIO_adr, z8reg_adr           'F0
                  add P2M_adr, z8reg_adr           'F6
                  add P3M_adr, z8reg_adr           'F7
                  add P01M_adr, z8reg_adr          'F8
      ''          add IPR_adr, z8reg_adr           'F9    nicht verwendet!
                  add IRQ_adr, z8reg_adr           'FA
                  add IMR_adr, z8reg_adr           'FB

                  add T_stat_adr, z8reg_adr
                  add R54_adr, z8reg_adr
                  add Tcode_adr, z8reg_adr
                  
'......I/O-Pinstatus Port 2/3 ermitteln und ausgeben an Propeller-Pins....................
'......Port 2.............................................................................
                  mov io_mask, #$00          wz     'Z-Flag setzen fr mux 
                  shl io_xxx, P2_mask
                  or io_mask, io_xxx 
            
'......Port 3.............................................................................
                  muxnz io_mask, P30_mask
                  muxz io_mask, P37_mask
                  muxnz io_mask, P33_mask
                  muxz io_mask, P34_mask
                  muxnz io_mask, P32_mask
                  muxz io_mask, P35_mask
                  muxz io_mask, P36_mask 
'.........................................................................................                  
                  mov dira, io_mask                 'I/O-Richtung ausgeben
                  
'-------------------------------------------------------------------------------------------                  
go                rdlong z8bus_val, z8bus_adr
                  rdbyte R3, R3_adr
                  rdbyte P3M, P3M_adr
                  rdbyte T_status, T_stat_adr
                  mov temp, #0
                  wrbyte temp, T_stat_adr
                  rdbyte P2M, P2M_adr              'Port2 I/O-Richtungsregister Z8 lesen  (Bit=1 -> Input) 
                  mov io_mask, dira                'IO-Richtungsregister Prop einlesen
                  rdbyte IMR, IMR_adr       
                  rdbyte IRQ, IRQ_adr              'einlesen IRQ-Status
                              
'......R54- Emulation (wegen Input-Tastaturroutine ohne T0-ISR)...........................
                  test T_status, #%0001_0000  wz
     if_nz        and t54_val, #$FF                      
     if_nz        sub t54_val, #1             wc
                  
'......per direktem Beschreiben R54 fr TINY...................................................
     if_nz        wrbyte t54_val, R54_adr          'schreiben

'.....Tastaturklick - Emulation................................................................
                  rdbyte temp, Tcode_adr           'Tastencoderegister 6D einlesen
                  test temp, #$80             wz   'Bit7 testen
     if_nz_and_c  xor R3, #$40                     'Bit6 in R3 = P36 negieren

'.....P2/3 - Emulation.........................................................................

'.....P2-Richtung...........................................................................
                  andn io_mask, io_xxx             'alte P2-Werte ausblenden      
                  mov temp, P2M                    'nach Arbeitsvariable und
                  xor temp, #$FF                   'bitweise negieren
                  shl temp, P2_mask                'verschieben um Portpinnummer 
                  or io_mask, temp                 'in IO-Richtungsregister Prop einfgen 
                  mov dira, io_mask                'I/O-Richtung fr alle Pins ausgeben
                  
'.....P2 - I/O - Werte lesen/schreiben........................................................
                  mov P2in, ina                    'Werte aller Pins einlesen
                  shr P2in, P2_mask                'P2_Wert auf Bitposition 0..7 verschieben
                  and P2in, P2M                    'Werte derOutputpins maskieren (0 setzen)
                  rdbyte temp, R2_adr              'Wert aus R02 einlesen
                  andn temp, P2M                   'alte Input-Werte ausblenden (0 setzen)
                  or temp, P2in                    'gelesene Input-Bits dazu und
                  wrbyte temp, R2_adr              'nach R02 zurckschreiben 
                  shl temp, P2_mask                'Wert verschieben um Portpinnummer
                  mov outa, temp '2                'und ausgeben auf Propeller-Pins

'.....P36 - Ausgabeemulation...................................................................
                  test R3, #$40         wz
                  muxz outa, P36_mask
'.................................................................................................
                   
{{......serielle I/O - Emulation....................................................................
  In Register F0 - SIO steht zu schreibendes/lesendes Byte und geht nach Puffer
  des seriellen Treibers.
  In Register FA- - IRQ steht auf IRQ3 (Bit3) Status fr seriellen Empfang:
                                1- wenn neues Byte, gesetzt durch IO-Cog    
                                0- wenn abgeholt, rckgesetzt durch Z8-Cog  
                              auf IRQ4 (Bit4) Status fr serielle Ausgabe: 
                                1- wenn neues Byte, gesetzt durch Z8-Cog    
                                0- wenn abgeholt, rckgesetzt durch IO-Cog      
'..........................................................................................}}
                  rdbyte IRQ, IRQ_adr              'einlesen Status
                  
'......schreiben - Byte ausgeben..........................................................
                  test IRQ, #%0001_0000    wz      'Status testen, Z=0, wenn neuer Ausgabewert
                  rdlong  temp,TxPtr               'Bereitschaft Puffer testen                                   
                  shl temp,#1              wc      'C=1, wenn bereit
     if_nc_or_z   jmp #Serin
                  rdbyte SIO, SIO_adr              'Registerwert einlesen
                  wrlong SIO,TxPtr                 'Write the byte into the transmitter
                  test P3M, #%0100_0000    wz      'Testen IRQ4 => T0 oder SIO?                                      
                  muxnz IRQ, #%0001_0000
                 
                  
'......lesen - Byte einlesen..............................................................                     
Serin             test IRQ, #%0000_1000    wz      'Status testen,
                  rdlong  temp,RxPtr               'Check the receiver                                   
                  shl temp,#1              wc      'Carry set if no byte available       
     if_nc_or_nz  jmp #SIO_end
                  wrlong temp, SIO_adr         '                                   
                  wrlong MinusOne, RxPtr           'Mark the byte as having been read                                     
                  andn IRQ, #%0000_1000 
'.........................................................................................
                  wrbyte IRQ, IRQ_adr
SIO_end 
'.........................................................................................
'......TIMER-Interrupt - Emulationen ..........................................................
                  test P3M, #%0100_0000   wz       'Testen IRQ4 => T0 oder SIO?
         if_nz    and T_status, #%0010_0000        'Timerstatus entspr. maskieren
         if_z     and T_status, #%0011_0000
                  or IRQ, T_status                 'in Interruptanmeldung einfgen
                  
                  andn IRQ, #%0001_0000            'T0-Interrupt ausblenden !!!!!!!!!!!!!
                  
                  wrbyte IRQ, IRQ_adr              'und zurckschreiben        
                  mov T_status, #0
                  wrbyte T_status, T_stat_adr
Timer_end  
'...............................................................................................
'......Interruptverarbeitung...........................................................................
                  test IMR, #%1000_0000   wz       'Interrupts global freigegeben?
         if_z     jmp #int_end                     'Sprung zurck,wenn nicht, sonst
                  mov IRQ_test, IRQ 
                  and IRQ_test, IMR       wz       'gesperrte Interruptanmeldungen ausblenden u. testen
         if_z     jmp #int_end                     'Sprung zurck,wenn keine gltigen Anforderungen, sonst

                  mov PC, PC_int                   'Pointer auf Interrupttabellenadresse IRQ 5  
                  mov temp, #5                     'Counter =5
                  mov temp2, #%0010_0000           'Maske auf IRQ5
:ma1              test IRQ_test, temp2    wz       'testen IRQ mit Maske
         if_nz    jmp #:ma2                        'wenn IRQ angemeldet und freigegeben, dann Sprung
                  sub PC, #3                       'sonst Tabellenadresse - 3
                  shr temp2, #1                    'Maske auf nchst niedrigen Interrupt
                  djnz temp, #:ma1                 'zurck, solange nicht 0, sonst
            
:ma2              or PC, INT_mask                  'IRQ-FLAG dazu
                  shl temp2, #16
                  or PC, temp2                     'IRQ dazu
                  wrlong PC, z8bus_adr             'nach Bus schreiben
int_end  
     
'------------------------------------------------------------------------------------------------------                                       
                  jmp #go
'---------------------------------------------------------------------------------------------------------

'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************                    
    
z8reg_adr     long   0
z8bus_adr     long   0
'ROM_adr       long   0
P2_mask       long   def#P2startpin
P30_mask      long   def#P30     
'P31_mask      long   def#P31     
P32_mask      long   def#P32     
P33_mask      long   def#P33     
P34_mask      long   def#P34     
P35_mask      long   def#P35     
P36_mask      long   def#P36     
P37_mask      long   def#P37      

t54_val        long   $ff00_0000
t54_const      long   $001f_ffff  
RxPtr         long   0
TxPtr         long   0   
io_xxx        long   $FF
MinusOne      long    -1
PC            long   0
INT_mask      long  %00100000_00000000_00000000_00000000      
'reset_mask    long  %10000000_00000000_00000000_00000000  

SIO_adr       long   def#SIO
P01M_adr      long   def#P01M
P2M_adr       long   def#P2M
P3M_adr       long   def#P3M

IRQ_adr       long   def#IRQ
'IPR_adr       long   def#IPR
IMR_adr       long   def#IMR
R0_adr        long   def#R0
R1_adr        long   def#R1
R2_adr        long   def#R2
R3_adr        long   def#R3
T_stat_adr    long   def#T_stat
R54_adr       long   $54
Tcode_adr     long   $6D 
PC_int        long   $0000_080F 

    
Mem            res   1
z8bus_val      res   1
io_mask        res   1
temp           res   1
temp2          res   1
z8reg_ptr      res   1
T_status       res   1
P2M            res   1
P2in           res   1
P3M            res   1
R3             res   1 

IRQ            res   1
irq_test       res   1
SIO            res   1
'IPR            res   1
IMR            res   1
 