''***************************************
''*  z8-Emulator  Objekt I/O & Interrupt*
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2012 by UN-Soft      *
''*  See end of file for terms of use.  *
''***************************************

' 

VAR   
   ' long  cog
OBJ
    def           : "tiny_4k_def"    

PUB start (z8reg)
z8reg_adr := z8reg  
      cognew(@main,z8reg)                                       'Timer-Cog starten
               

DAT 'TIMER- Cog
org 0
'******************************************************************************************************
'---- Mainloop ----------------------------------------------------------------------------------------
'******************************************************************************************************                  
main              mov Mem, par
                
'......Systemregister F0 - FB...........................
                  add R3_adr, z8reg_adr            '03
                  add TMR_adr, z8reg_adr           'F1
                  add T1_adr, z8reg_adr            'F2
                  add PRE1_adr, z8reg_adr          'F3
                  add T0_adr, z8reg_adr            'F4
                  add PRE0_adr, z8reg_adr          'F5

                  add T0wr_adr, z8reg_adr
                  add T1wr_adr, z8reg_adr
                  add T_stat_adr, z8reg_adr

                  mov T_stat, #$00                         
'.........................................................................................                  
                  mov pre0_val,#1
                  mov pre1_val,#1
                  mov T0, #0
                  mov T1, #0
                  mov T_stat, #0
                                                        
'-------------------------------------------------------------------------------------------                  
{{.....TIMER - Emulationen ...............................................................}}
'-------------------------------------------------------------------------------------------
go                rdbyte TMR, TMR_adr
'......Zeitschleife fr Testzwecke
:ma  '             add t0_test, t0_sub_val  wc     'test
     ' if_nc       jmp #:ma                     'test
                
'-------------------------------------------------------------------------------------------                                 
'------T0 - Emulation-----------------------------------------------------------------------
'-------------------------------------------------------------------------------------------
t0_start          test TMR, #%0000_0001  wz
      if_nz       call #t0_set  
                  test TMR, #%0000_0010  wz
      if_z        jmp #t0_end            
      
pre0_start        and pre0_tmp, #$FF              'PRE0 begrenzen und testen auf 0, setze C 
                  sub pre0_tmp, #1       wc
      if_c        mov pre0_tmp, pre0_val          'wenn Vorteiler =0, dann neu laden
      if_c        sub T0, #1                      'wenn Vorteiler =0, Zhler -1
      if_c        and T0, #$ff           wz       'wenn Vorteiler =0 und Zhler Nulldurchgang setze Z 
      if_c        wrbyte T0, T0_adr               'wenn Vorteiler =0, schreibe Zhlerstand nach T1
      if_nc_or_nz jmp #t0_end      

'----------------------------------------------   'wenn Zhler =0
                  test TMR, #%0100_0000  wz       'Ausgabe T0?
      if_nz       call #R36_set                   'dann R3-Bit6 = P36 invertieren
                  or  T_stat, #%0001_0000         'Status 
                                  
                  test PRE0, #%0000_0001 wz       'T1 Single-Pass?   
      if_z        andn TMR, #%0000_0010
                  call #t0_set                    'Werte neu einlesen      
t0_end        

'-------------------------------------------------------------------------------------------                                 
'------T1 - Emulation-----------------------------------------------------------------------
'-------------------------------------------------------------------------------------------        
t1_start          test TMR, #%0000_0100  wz
      if_nz       call #t1_set  
                  test TMR, #%0000_1000  wz
      if_z        jmp #t1_end            
      
pre1_start        and pre1_tmp, #$FF              'PRE1 begrenzen und testen auf 0, setze C 
                  sub pre1_tmp, #1       wc
      if_c        mov pre1_tmp, pre1_val          'wenn Vorteiler =0, dann neu laden
      if_c        sub T1, #1                      'wenn Vorteiler =0, Zhler -1
      if_c        and T1, #$ff           wz       'wenn Vorteiler =0 und Zhler Nulldurchgang setze Z 
      if_c        wrbyte T1, T1_adr               'wenn Vorteiler =0, schreibe Zhlerstand nach T1
      if_nc_or_nz jmp #t1_end      

'----------------------------------------------   'wenn Zhler =0
                  test TMR, #%1000_0000  wz       'Ausgabe T1?
      if_nz       call #R36_set                   'dann R3-Bit6 = P36 invertieren
                  or T_stat, #%0010_0000          'Status 
                                  
                  test PRE1, #%0000_0001 wz       'T1 Single-Pass? 
      if_z        andn TMR, #%0000_1000
                  call #t1_set                    'Werte neu einlesen 
t1_end           
'---------------------------------------------------------------------------------------------------------
timer_end         wrbyte T_stat, T_stat_adr       'Status schreiben  
'                  and TMR, #%0000_1010   wz
'      if_nz       jmp #go
'                  rdbyte R3, R3_adr
'                  andn R3, #$40  
'                  wrbyte R3, R3_adr

          
                  jmp #go


'---------------------------------------------------------------------------------------------------------
'-Subroutines --------------------------------------------------------------------------------------------      
'---------------------------------------------------------------------------------------------------------
R36_set           rdbyte R3, R3_adr
                  xor R3, #$40
                  wrbyte R3, R3_adr
R36_set_ret       ret
'.........................................................................................................
t0_set            rdbyte T0, T0wr_adr             'Zhlerstand neu einlesen
                  rdbyte PRE0, PRE0_adr           'Vorteilerwert neu holen
                  mov pre0_val, PRE0
                  shr pre0_val, #2       wz
      if_z        mov pre0_val,#64
      if_z        mov pre0_tmp, pre0_val
                  andn TMR, #%0000_0001
                  wrbyte TMR, TMR_adr
t0_set_ret        ret
'.........................................................................................................
t1_set            rdbyte T1, T1wr_adr             'Zhlerstand neu einlesen
                  rdbyte PRE1, PRE1_adr           'Vorteilerwert neu holen
                  mov pre1_val, PRE1
                  shr pre1_val, #2       wz
      if_z        mov pre1_val,#64
      if_z        mov pre1_tmp, pre1_val
                  andn TMR, #%0000_0100
                  wrbyte TMR, TMR_adr
t1_set_ret        ret      

'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************                    
z8reg_adr     long   0    
R3_adr        long   def#R3
TMR_adr       long   def#TMR
PRE0_adr      long   def#PRE0
T0_adr        long   def#T0
PRE1_adr      long   def#PRE1
T1_adr        long   def#T1

T0wr_adr      long   def#T0_wr
T1wr_adr      long   def#T1_wr
T_stat_adr    long   def#T_stat
t0_test       long   $0000_0000
t0_sub_val    long   $0800_0000

Mem           res   1
z8reg_ptr     res   1
TMR           res   1
PRE0          res   1
PRE1          res   1
T0            res   1
T1            res   1
pre0_val      res   1
pre0_tmp      res   1
pre1_val      res   1
pre1_tmp      res   1
T_stat        res   1
temp          res   1
R3            res   1
fit
 