''***************************************
''*  z8Emulator v1.2  fr TINY 4k-System*
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2012                 *
''*  See end of file for terms of use.  *
''***************************************
'Version
' 
' - Ansteuerung virtueller ROM/RAM des TINY durch Emulator-Cog fr Z8
' - Tastaturabfrage: Treiber setzt Zellen im RAM entspr. Tastaturmatrix
' - Steuerung des Berechnungs-Cog ber festlegbares Doppelregister des Z8, Standard: RR0
'     - R0 enthlt Kommandonummer (z.B 00 fr Ausgabe BWS)
'     - R1 enthlt je nach Kommando in R0 weitere Daten
' - SD_Routinen fr Save/Load, nderung Original-ROM
' - zustzliche Kommandos im TINY-ROM integriert: D - Dir, X - Delete, C - Call Programm
'===============================================================================================================================
' Register Z8 im HUB-RAM
' Speicher Z8 im HUB-RAM
' div. Kommandos im HUB-RAM
'================================================================================================================================
OBJ
    def           : "tiny_4k_def" 
    intio         : "intio-z8emu"
    timer         : "timer-z8emu"
    moni          : "vga-z8emu"
    calcvga       : "calc-z8emu"   
    kb            : "keybdrv-z8emu"
'    Commser       : "serial-z8emu" 
    sd            : "fsrw-z8emu"               
    
CON
  _clkmode = def#clk_mode
  _xinfreq = def#xin_freq

VAR   
' Emulator..............................................................................
'    long z8bus
         
' VGA etc...............................................................................
    long  sync
    long  mode_base  
    long  shift_adr     
    long  CommPtr
    
    long  cbuff_adr
        
DAT               
'.....Definition TINY- Speicher ........................................................................
ROMx           file "4ksystem_z8emu.bin" 
KEYx           byte $00 [def#key_len +1]     
RAMx           byte $00 [def#ram_len]
REGx           byte $00 [$102]    
z8bus          long $00   
col_base       word $00 [def#lencol]
bitmap_base    long $00 [def#lenbmp]

PUB Main     | err

'HUB-Ram Speicheradressen     
 z8reg_adr   := @REGx    
 rombaseadr  := @ROMx
 rambaseadr  := @RAMx
 keybaseadr  := @KEYx
 calc_adr    := @REGx + def#calccmdreg 
 ldxx_adr    := @ldxx
 ldcx_adr    := @ldcx
 daadd_adr   := @daadd
 dasub_adr   := @dasub
 tcmx_adr    := @tcmx
 grp_Fx_adr  := @grp_Fx
 cond_adr    := @cond
 grp_jmp_adr := @grp_jmp
 x0_adr      := @x0_jmp
  
'Initialisierungs- und Standardwerte     
 mode_base   := (def#stdmodus >> 1) & 1           'Tile-Mode fr VGA-Treiber
' cbuff_adr   := @RAMx + def#cbuff_offset     
 
'VGA-Treiber starten       
     moni.start (def#vgapin,@col_base,@bitmap_base,@mode_base,@sync)
    
'Berechnungs_Cog starten         
     calcvga.start(@RAMx,@ROMx,@bitmap_base,@col_base,@REGx)         
         
'Keyboard starten       
     kb.startx (def#kbdata, def#kbclock,def#lockxx,def#autoxx,@KEYx,@RAMx + def#ram_len-1)                             
     
'RS232-Ein/Ausgabe starten
 '    CommPtr := Commser.start(def#RxPin,def#RxMode,def#CtsPin,def#CtsMode,def#TxPin,def#TxMode,def#DtrPin,def#DtrMode,def#Baudrate)    

'Interrupt und I/O starten
     intio.start(@REGx,@ROMx,@z8bus,CommPtr)
'TIMER starten
     timer.start(@REGx)            
       
'TINY-Cog starten
     cognew(@START,@z8bus)

 repeat
   
   case byte[calc_adr]
      $10..$1F:
         case byte[calc_adr]

              $10:                                                                                                                                
                err := \sd.startSD (@RAMx,@ROMx)
              $11:                                                                                                                                
                err := \sd.save_tiny                                                                                
              $12:                                                                                                                                
                err := \sd.load_tiny ("h") 
              $13:                                                                                                                                
                err := \sd.load_tiny ("d") 
              $14:                                                                                                                                
                err := \sd.dir_tiny 
                            
              $15: 
                err := \sd.del_tiny 
                                                                                
              $1F:                                                                                                                                
                err := \sd.stopSD 
          
         byte[calc_adr +1] := err         
         byte[calc_adr] := 0                                                                                                               
   
           
DAT
'....LMM- Programmteile.................................................................................                                 

ldxx              mov temp3, nval
                  shr nval, #8
                  mov sd_typ, #1
                  mov mode, #1
                  call #r_left_x
                  mov sd_typ, #2
                  mov mode, #1
                  call #r_right_y
                  and temp3, #$FF       
                  add val2, temp3
                  mov regnr, val2
             '     mov sd_typ, #2
                  call #get_REGval2
                  cmp cmd_nr, #$0C
         if_z     jmp #dst_end
                  mov regnr, src_regnr
                  mov regval, val1
                  jmp #set_end
'...................................................................
ldcx              ror ival, #8                        'absolute Registernummer                                                                              
                  mov regnr, ival                     'nach <regnr>                                                                                         
                  call #get_Irr                       'Adresse aus Doppelregister holen   (Irr)                                                             
                  mov tempval, PC                     'PC retten                                                                                            
                  mov PC, regval                      'Adresse nach PC                                                                                      
                  cmp cmd_grp, #2               wz                                                                                                          
          if_z    jmp #ldcci                                                                                                                                
                  sub regnr, #1                       'Doppelregisternummer auf 1.Register zurcksetzen                                                     
                  call #inc_Irr                       'incrementiere Adresse und nach Doppelregister zurckschreiben                                        
                  mov regnr, dst_regnr                '                                                                                                     
                  mov regval, val1                    '<val1> ist Registernummer (Ir)                                                                       
                  add regval, #1                      'inkrementiere Ir                                                                                     
                  call #set_REGval                    'und nach Register zurckschreiben                                                                    
                  mov regnr, val1                     '<val1> ist Registernummer (Ir)                                                                       
                  mov dst_regnr, val1                                                                                                                       
                  call #get_REGval2                    'Registerinhalt nach <regval>                                                                         
                  mov val1, regval                                                                                                                          
                  jmp #ldcci         

'.....................................................................................................
tcmx              xor val1, #$FF 
                  and val1, val2          wz
                  muxz FLAG, #%0100_0000
                  test val1, #$80         wz
                  muxz FLAG, #%0010_0000
                  and FLAG, #%1110_1111  
                  wrbyte FLAG, flag_adr 
                  jmp #PCinc                  
'.....................................................................................................
daadd             mov temp, val1                    'Wert laden
                  shr temp, #4                      'und in Halbbytes
                  mov temp2, val1                   'extrahieren
                  and temp2,#$0F
                  test FLAG, #%1000_0000  wz        'teste Carry
                                                                       
    if_nz         cmp temp2, #$0A         wc        'wenn C=1 teste D3..D0 auf A..F
    if_nz_and_nc  mov val2, #$66                    'wenn C=1 und D3..D0 -> A..F, dann addiere 66
    if_nz_and_c   mov val2, #$60                    '                    -> 0..9, dann addiere 60
    if_nz         jmp #calc                         'wenn C=1 zurck

'...C=0...............................................................
                  cmp temp, #$09          wc        'teste D7..D4 
    if_nc         cmp temp2, #$0A         wc        'wenn D7..D4 -> 9..F teste D3..D0 -> A..F
    if_nc         mov val2, #$66                    'dann addiere 66
    if_nc         or FLAG, #%1000_0000              'setze C=1
    if_nc         wrbyte FLAG, flag_adr
    if_nc         jmp#calc                          'und zurck

                  cmp temp, #$0A          wc        'teste D7..D4  auf A..F
    if_nc         test FLAG, #%0000_0100  wz        'wenn ja, dann teste H-Flag
    if_nc_and_nz  mov val2, #$66                    'wenn A..F und H=1, addiere 66
    if_nc_and_z   mov val2, #$60                    'wenn A..F und H=0, addiere 60
    if_nc         or FLAG, #%1000_0000              'wenn A..F setze C=1
    if_nc         wrbyte FLAG, flag_adr      
    if_nc         jmp#calc                          'und zurck
 
                  cmp temp2, #$0A         wc        'teste D3..D0 auf A..F
                  test FLAG, #%0000_0100  wz        'teste H-Flag
    if_nc_or_nz   mov val2, #$06                    'wenn  A..F oder H=1 addiere 6
    if_nc_or_nz   jmp#calc                          'und zurck, sonst
                  mov val2, #$00                    'addiere 0
                  jmp#calc                          'und zurck
'.....................................................................................................  
dasub             mov val2, #0
                  test FLAG, #%1000_0000  wz
    if_z          test FLAG, #%0000_0100  wc
    if_z_and_c    mov val2, #$0A
    if_z_and_nc   mov val2, #$A0
    if_z          jmp #calc
    
                  test FLAG, #%0000_0100  wz
    if_z          mov val2, #$FA
                  jmp#calc
'.....................................................................................................
grp_Fx            cmp cmd, #$FF            wz      'nop
        if_z      jmp #PCinc
                  cmp cmd, #$CF            wz, wc  'rcf    
        if_z      and FLAG, #%0111_1111      
                  cmp cmd, #$EF            wz      'ccf    
        if_z      xor FLAG, #%1000_0000 
                  cmp cmd, #$DF            wz      'scf    
        if_z      or FLAG, #%1000_0000
        if_nc     wrbyte FLAG, flag_adr                        
                 
eidi              cmp cmd, #$9F            wz      'ei    
        if_z      or IMR, #%1000_0000
                  cmp cmd, #$8F            wz      'di    
        if_z      and IMR, #%0111_1111
                  wrbyte IMR, IMR_adr
                  jmp #PCinc       
'.....................................................................................................
cond              mov temp, cmd_nr
                  cmp temp, #$08         wz, wc
                  andn temp, #$08
                  mov temp2, #%0000_0001
                  shl temp2, temp
                  andn temp2, #$1
                  mov temp, temp2
                  and temp2, FLAG                  'maskieren nicht benutzter Flags
    if_c          mov temp3, temp                  'wenn cmd 0x...7x, dann Vgl.-Wert <temp> (Flag gesetzt)
    if_nc         mov temp3, #0                    'wenn cmd 8x...Fx, dann Vgl.-Wert 0 (Flag rckgesetzt)
                  test cmd_nr, #%0000_0100   wz    'Test ob cmd 4x...7x, Cx...Fx                                                          
    if_nz         jmp #cond_end                    'wenn ja Sprung zur Auswertung , sonst
                                                   'Berechnung der kombinierten Bedingungen
                  test FLAG, #%0011_0000     wc
                  muxc temp2, #%0000_0010          'S xor V       - lt, ge
                  test FLAG, #%0100_0000     wz
    if_nz_or_c    or temp2, #%0000_0100            'Z or(S xor V) - le, gt
                  test FLAG, #%1100_0000     wz
                  muxnz temp2, #%0000_1000         'C or Z        - ule, ugt
                  
                  and temp2, temp                  'Auswahl der Bedingung und
                  jmp #cond_end                    'Sprung zur Auswertung

'.....CMD-Gruppen-Sprungverteiler.......................................................................
'                   1.Aktion   2.Aktion         Parameter 1._2. Aktion  letzte Akt. 
'                                              (sdtyp|mode_sdtyp|mode )             
grp_jmp        word rd_REG_x  ,cmdjmp_calc          ,$12_00            ,0           '0
               word rd_REG_x  ,cmdjmp_calc          ,$13_00            ,0           '1   
               word r_right_x ,r_left_x             ,$21_11            ,cmdjmp_calc '2   
               word r_right_x ,r_left_x             ,$22_11            ,cmdjmp_calc '3   
               word rd_REG_x  ,rd_REG_x             ,$22_12            ,cmdjmp_calc '4   
               word rd_REG_x  ,rd_REG_x             ,$23_12            ,cmdjmp_calc '5     
               word rd_REG_x  ,rd_n                 ,$12_60            ,cmdjmp_calc '6   
               word rd_REG_x  ,rd_n                 ,$13_60            ,cmdjmp_calc '7
               word rd_REG_x  ,REGcmd               ,$32_00            ,set_end     '8
               word REGcmd    ,rd_REG_x             ,$01_01            ,set_end     '9   
               word REGcmd    ,set_REGvalminus      ,$01_00            ,grp_A       'A   
               word grp_B     ,0                    ,$00_00            ,0           'B
               word grp_C     ,0                    ,$00_00            ,0           'C   
               word grp_D     ,0                    ,$00_00            ,0           'D   
               word REGcmd    ,grp_E                ,$11_00            ,0           'E   
               word grp_F     ,0                    ,$00_00            ,0           'F

'.....CMD-Sprungverteiler...............................................................................
'                 CMD-Jump    Aktion    Flags           
x0_jmp         word calc1   ,%100001001_0111000    'dec           0    GRUPPE 0 und 1 
               word rlc     ,%001001001_1111000    'rlc           1
               word calc1   ,%100000001_0111000    'inc           2
               word grp0_1  ,%000000000_0000000    'jpIRR         3
               word da      ,%100000001_0110000    'da            4
               word pop     ,%000000000_0000000    'pop           5
               word com     ,%011011001_0110000    'com           6          
               word push    ,%000000000_0000000    'push          7
               word idw     ,%100001001_0111001    'decw          8
               word rl      ,%001001001_1111000    'rl            9
               word idw     ,%100000001_0111001    'incw          A
               word clrR    ,%000000000_0000000    'clr           B
               word rrc     ,%001010001_1111000    'rrc           C
               word sra     ,%001010001_1111000    'sra           D
               word rr      ,%001010001_1111000    'rr            E
               word swap    ,%001010001_0110000    'swap          F

'.......................................................................................................
               word addc    ,%100000001_1111010    'add           0      GRUPPE 2      
               word addc    ,%110010001_1111010    'adc           1              
               word subc    ,%100001001_1111010    'sub           2
               word subc    ,%110011001_1111010    'sbc           3
               word aox     ,%011010001_0110000    'or            4
               word aox     ,%011000001_0110000    'and           5
               word tcm     ,%011000000_0110000    'tcm           6
               word aox     ,%011000000_0110000    'tm            7
               word ldc_ci  ,pm_read               'lde r,Irr     8            
               word ldc_ci  ,pm_write              'lde Irr,r     9              
               word calc    ,%100001000_1111000    'cp            A
               word aox     ,%011011001_0110000    'xor           B
               word ldc_ci  ,pm_read               'ldc r,Irr     C
               word ldc_ci  ,pm_write              'ldc Irr,r     D
               word PCinc   ,%000000000_0000000    'no Opcode     E
               word PCinc   ,%000000000_0000000    'no Opcode     F
'.......................................................................................................

               word ldc_ci  ,pm_read               'ldei Ir,Irr   8     GRUPPE 3        
               word ldc_ci  ,pm_write              'ldei Irr,Ir   9              
               word calc    ,%100001000_1111000    'cp            A
               word aox     ,%011011001_0110000    'xor           B
               word ldc_ci  ,pm_read               'ldciIr,Irr    C
               word ldc_ci  ,pm_write              'ldci Irr,Ir   D
               word calc    ,%101000001_0000000    'ld r,IR       E
               word ldIrrF  ,%000000000_0000000    'ld Ir,r       F
'.......................................................................................................

               word PCinc   ,%000000000_0000000    'no opcode     8      GRUPPE 4       
               word PCinc   ,%000000000_0000000    'no opcode     9             
               word calc    ,%100001000_1111000    'cp            A
               word aox     ,%011011001_0110000    'xor           B
               word cmd1    ,%000000000_0000000    'no opcode     C
               word callIRR ,%000000000_0000000    'call_IRR      D
               word calc    ,%101000001_0000000    'ld_RR         E
               word PCinc   ,%000000000_0000000    'no opcode     F
'.......................................................................................................

               word PCinc   ,%000000000_0000000    'no opcode     8      GRUPPE 5       
               word PCinc   ,%000000000_0000000    'no opcode     9              
               word calc    ,%100001000_1111000    'cp            A
               word aox     ,%011011001_0110000    'xor           B
               word PCinc   ,%000000000_0000000    'no opcode     C
               word PCinc   ,%000000000_0000000    'no opcode     D
               word calc    ,%101000001_0000000    'ldR_IR        E
               word ldIrrF  ,%000000000_0000000    'ldIR_R        F
'.......................................................................................................
 
               word PCinc   ,%000000000_0000000    'no opcode     8      GRUPPE 6      
               word PCinc   ,%000000000_0000000    'no opcode     9              
               word calc    ,%100001000_1111000    'cp            A
               word aox     ,%011011001_0110000    'xor           B
               word PCinc   ,%000000000_0000000    'no opcode     C
               word calladr ,%000000000_0000000    'calladr       D
               word calc    ,%101000001_0000000    'ldR_n         E
               word PCinc   ,%000000000_0000000    'no opcode     F
'.......................................................................................................
  
               word PCinc   ,%000000000_0000000    'no opcode     8      GRUPPE 7       
               word PCinc   ,%000000000_0000000    'no opcode     9              
               word calc    ,%100001000_1111000    'cp            A
               word aox     ,%011011001_0110000    'xor           B
               word ldrX    ,%000000000_0000000    'ldr_X         C
               word ldrX    ,%000000000_0000000    'ldX_r         D
               word calc    ,%101000001_0000000    'ldIR_n        E
               word PCinc   ,%000000000_0000000    'no opcode     F

DAT  
org 0
'******************************************************************************************************
'*---- Z8 Command- Cog -------------------------------------------------------------------------------*
'******************************************************************************************************  
START             mov z8bus_adr, Par               'Adresse Bus  einlesen
                  add flag_adr, z8reg_adr
                  add IRQ_adr, z8reg_adr
                  add IMR_adr, z8reg_adr
                  add RP_adr, z8reg_adr
                  add SPH_adr, z8reg_adr
                  add SPL_adr, z8reg_adr
                  mov SP_adr, rambaseadr
                  sub SP_adr, ram_s   
reset             mov PC, #$0C                     'Startwerte laden
            '      mov mode, #0   
                            
'------Hauptschleife-----------------------------------------------------------------------------------              
cmd1                  
'......Systemregister einlesen.........................................................................
                  rdbyte IMR, IMR_adr              'einlesen IMR,FLAG,RP,SPL,SPH
                  rdbyte IRQ, IRQ_adr
                  rdbyte FLAG, flag_adr
                  rdbyte RP, RP_adr
                  rdbyte SP, SPH_adr
                  rdbyte temp, SPL_adr
                  shl SP, #8
                  or SP, temp 

'------------------------------------------------------------------------------------------------------ 
                  rdlong z8bus_val, z8bus_adr      'Bus einlesen
                  test z8bus_val, reset_mask  wz   'Testen auf Reset (Reset=1)
        if_nz     jmp #reset                       'Sprung, wenn ja
      
'------------------------------------------------------------------------------------------------------              
'......Interruptverarbeitung...........................................................................
                  test IMR, #%1000_0000   wz       'Interrupts global freigegeben (bit7=1)?
         if_z     jmp #RD_Command                  'Sprung, wenn nicht, sonst
                  test z8bus_val, INT_mask  wz     'Interruptforderung von intio-cog?
         if_z     jmp #RD_Command                  'Sprung, wenn nicht, sonst
         
'......Interruptannahme................................................................................       
do_int            andn IMR, #%1000_0000            'globale Interruptsperre  (bit7=0)
                  wrbyte IMR, IMR_adr              'setzen
                  call #PC2ST                      'PC retten
                  mov temp, FLAG                   'FLAG                                          
                  call #ST_write                   'retten
                  mov PC, z8bus_val                'Adresse ISR holen
                  and PC, adrdat_mask              
                  shr z8bus_val, #16
                  and z8bus_val, #$FF
                  andn IRQ, z8bus_val              'IRQ rcksetzen
                  wrbyte IRQ, IRQ_adr              'und zurckschreiben 
                  wrlong z8bus_val, z8bus_adr      'Interruptannahme an intio-cog zurckmelden
  
'------einlesen PC, 1.Byte Befehl(Kommando) -----------------------------------------------------------
RD_Command        call #pm_read                    'Bus einlesen
                  mov arg_adr, adr_val
                  add adr_val, #1
                  rdbyte arg1, adr_val             'look ahead nchstes Byte als Argument lesen 
                  add adr_val, #1
                  rdbyte arg2, adr_val             'look ahead nchstes Byte als Argument lesen
             
                  mov  cmd, temp                   'Daten => Cmd
                  mov  cmd_grp, cmd                '
                  and  cmd_grp, #$0F               'Cmd-Gruppe extrahieren
                  mov  cmd_nr, cmd
                  shr  cmd_nr, #4                  'Cmd-Nummer extrahieren
 
'.....CMD-Sprung Adresse berechnen......................................................................
                  mov ival, #0 
                  mov cmdhub_adr, grp_jmp_adr      'Basisadresse Gruppen-Sprungverteiler nach Zeiger <cmdhub_adr>
                  mov temp, cmd_grp                'Kommandogruppe fr weitere Berechnung
                  shl temp, #3                     'verachtfachen wegen 4*Word
                  add cmdhub_adr, temp             'und Offset zu Basisadresse im Hub addieren
                  
                  rdword cpart1, cmdhub_adr
                  add cmdhub_adr, #2
                  rdword cpart2, cmdhub_adr   wz
          if_z    jmpret all_end, cpart1         
                  add cmdhub_adr, #2   
                  rdword mdsel1, cmdhub_adr   wz
          if_z    jmp #:maxx        
                  add cmdhub_adr, #1   
                  rdbyte mode,   cmdhub_adr
                  add cmdhub_adr, #1   
                  rdbyte cpart3, cmdhub_adr 

:maxx             mov sd_typ, mode 
                  and mode, #$0F
                  shr sd_typ, #4
:ma1              jmpret all_end, cpart1            'UP's aus Tabelle ausfhren !!modifizierter Befehl!!

                  mov mode, mdsel1
                  mov sd_typ, mdsel1   
                  and mode, #$0F
                  shr sd_typ, #4
:ma2              jmpret all_end, cpart2            '!!Alle in Tabelle verwendeten UP's mssen mit rd_REG_ret-Marke  _
:ma3              jmpret all_end, cpart3            '  bei ret enden oder aber Sprung!
                 
'-----------------------------------------------------------------------------------------------------------                   
cmdjmp_calc       mov cmdhub_adr, x0_adr            'Basisadresse CMD-Sprungtabelle nach Zeiger <cmdhub_adr>
                  mov temp, cmd_nr  

                  cmp cmd_grp, #$02       wz, wc
         if_c     jmp #ma1                          'wenn Gruppe < 2 Sprung
                  add cmdhub_adr,#16*4              'Tabellenbasisadresse + 16
         if_z     jmp #ma1                          'wenn Gruppe = 2 Sprung
                  cmp cmd_nr, #$08          wc      'Kommandonummer testen auf < 8
         if_c     jmp #ma1                          'wenn Nummer < 8 Sprung

                  add cmdhub_adr,#8*4 
                  andn temp, #$08
                  sub cmd_grp, #2  
:ma2              add cmdhub_adr, #8*4
                  djnz cmd_grp, #:ma2
                        
ma1                                                'einlesen aus Tabelle
                  shl temp, #2                     'vervierfachen wegen 2*Word
                  add cmdhub_adr, temp             'und Offset zu Basisadresse im Hub addieren
                  rdword cmdjmp, cmdhub_adr
                  add cmdhub_adr, #2
                  rdword action, cmdhub_adr
                  movs ldcci_ma, action  
                  mov flag_mask, action            'Flagmaske extrahieren
                  shl flag_mask, #1
            '      and flag_mask, #$FF
                  shr action, #7   
                  jmp cmdjmp                       'Sprung zu Adresse im Verteiler
'........................................................................................................

'******************************************************************************************************                   
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe xF   - div. Programmsteuerung
'---------------------------------------------------------------------------------------------------------
grp_F             cmp cmd, #$AF               wz   'ret
ret_up  if_z      jmp #ret_xx
                  cmp cmd, #$BF               wz   'iret
        if_z      jmp #iret_xx
                  mov hubadr, grp_Fx_adr
                  jmp #vm
'.........................................................................................................
ret_xx            call #ST2PC                      'PC vom Stack holen
                  jmp #cmd1
'.........................................................................................................
iret_xx           call #ret_flag                   'Flag und PC vom Stack holen
irq_on        '    rdbyte IMR, IMR_adr
                  or IMR, #%1000_0000  
                  wrbyte IMR, IMR_adr
                  jmp #cmd1
                                                                    
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe xE   - inc r
'---------------------------------------------------------------------------------------------------------
grp_E             mov action, #%100000001          'add                                                 ok
                  mov flag_mask, #%0111_0000       'Z,S,V-Flag
'......................................................................................................      
calc1             mov val2, #$01                   'Operationen mit '1'

'..... Arithmetik- Routine (val1, val2)................................................................
calc              test FLAG, #%1000_0000      wc   'Carry Z8 -> Carry Prop fr Berechnungen mit C
                  test action, #%000000001    wz   'Result schreiben?
                  or action, #%000000001           'immer Result schreiben setzen, wegen Flagberechnung CSV
                  and val2, #$FF
                  call #calcx    
           
        if_nz     mov tempval, resultx             'schreibe Result, wenn gesetzt
        if_z      mov tempval, val1                'sonst ist Result der urspr. Wert
                  tjz flag_mask, #calc_end         'wenn Cmd ohne Flagbeeinflussung, dann Sprung

'......FLAG-Routine....................................................................................
                  mov temp, #0
                  test resultx, #$80          wz   'S-Flag   
                  muxnz temp, #%0010_0000
                  test resultx, #$100         wz   'C-Flag   
                  muxnz temp, #%1000_0000
                  test resultx, #$FF          wz   'Z-Flag
                  muxz temp, #%0100_0000
                  and val1, #$7F                   'V-Flag 
                  and val2, #$7F
                  call #calcx
                  test resultx, #$80          wz   'Test ob Carry-In nach bit7
         if_z     mov temp2,#%1000_0000 
         if_nz    mov temp2, #%0000_0000
                  xor temp2, temp                  'Carry-In xor Carry-Out -> V
                  test temp2, #$80            wz
                  muxz temp, #%0001_0000
         '........................................................
                  and val1, #$0F                   'H-Flag 
                  and val2, #$0F
                  call #calcx
                  test resultx, #$10          wz
                  muxnz temp, #%0000_0100
          '.......................................................        
                  and temp, flag_mask         
                  andn FLAG, flag_mask  
                  or FLAG, temp
                  wrbyte FLAG, flag_adr 
'......................................................................................................
calc_end          mov regval, tempval
dst_end           and regval, #$ff
set_end2          mov regnr, dst_regnr 
set_end           call #set_REGval
PCinc             add PC, #1                    
                  jmp #cmd1

'......................................................................................................
calcx             movi :ma1, action
                  mov resultx, val1
:ma1              add resultx, val2                'modifizierter Befehl!!      
calcx_ret         ret

'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe xD   - jmp cc,nn
'---------------------------------------------------------------------------------------------------------
grp_D             cmp cmd_nr, #1      wc           'illegaler Opcode 0D (verwendet im ROM des TINY)
         if_c     jmp #PC3inc                      'Sprung, wenn ja
                  call #condit
         if_z     jmp #jump_abs                    'wenn erfllt, springen
PC3inc            add PC, #3                       'sonst PC auf nchsten Befehl setzen (PC+3)
                  jmp #cmd1                        'und zurck  
                  
jump_abs          shl arg1, #8
                  or arg1, arg2
                  mov PC, arg1 
                  jmp #cmd1
 
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe xC   - ld r,n
'---------------------------------------------------------------------------------------------------------
grp_C             mov regnr, cmd_nr
                  or regnr, RP
                  mov regval, arg1
                  add PC, #1
                  jmp #set_end
            
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe xB   - jr cc,nn
'---------------------------------------------------------------------------------------------------------
grp_B             cmp cmd_nr, #1      wc           'illegaler Opcode 0B? (verwendet in ISR des TINY)
         if_c     jmp #PC2inc                      'Sprung, wenn ja
                  call #condit
         if_nz    jmp #PC2inc
jump_rel          test arg1, #$80     wz
         if_z     add PC, #2
         if_nz    sub PC, #$FE 
                  add PC, arg1 
                  jmp #cmd1 
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe xA   - djnz r,n
'---------------------------------------------------------------------------------------------------------
grp_A             tjnz regval, #jump_rel
PC2inc            add PC, #2      
                  jmp #cmd1
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x9   - ld R,r
'---------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x8   - ld r,R
'---------------------------------------------------------------------------------------------------------

'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x7   - IR,n
'---------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x6   - R,n
'---------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x5   - R,IR
'---------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x4   - R,R
'---------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x3   - r,IR
'---------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x2   - r,r
'---------------------------------------------------------------------------------------------------------
 '--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x1   - IR
'---------------------------------------------------------------------------------------------------------
'--------------------------------------------------------------------------------------------------------- 
'CMD-Gruppe x0   - R
'---------------------------------------------------------------------------------------------------------
 
                 
'*********************************************************************************************************

'--------------------------------------------------------------------------------------------------------- 
'CMD-Aktionen ********************************************************************************************
'---------------------------------------------------------------------------------------------------------
ldIrrF            mov regnr, val1
                  mov regval, src_regnr
                  jmp #set_end
'......................................................................................................          
idW               call #Irr
                  mov temp, regval
                  cmp cmd_nr, #$0A           wz
        if_z      add regval, #1
        if_nz     sub regval, #1
                  mov regnr, dst_regnr 
                  call #set_IRR
                  andn FLAG, flag_mask
                  test regval, v_16        wz        'S-Flag 
                  muxnz FLAG, #%0010_0000     
                  cmp regval, #$00         wz        'Z-Flag
                  muxz FLAG, #%0100_0000
                  xor regval, temp                   'H-Flag   
                  test regval, #$100       wz
                  muxnz FLAG, #%0000_0100
                  wrbyte FLAG, flag_adr
                  jmp #PCinc                         'zurck
'......................................................................................................                                                        '
clrR              mov regval, #0                      '                                         
                  jmp #set_end
'......................................................................................................
pop               call #ST_read                       'Stack nach <temp>
                  jmp #set_end2
'......................................................................................................
push              call #ST_write
                  jmp #PCinc
'......................................................................................................             
calladr           add PC, #1
                  call #PC2ST
                  jmp #jump_abs 
'......................................................................................................
callIRR           call #PC2ST
                  mov regnr, src_regnr
                  jmp #jpIRR2
grp0_1            cmp cmd_grp, #1       wz
         if_z     jmp #srp
jpIRR             mov regnr, dst_regnr
jpIRR2            call #get_IRR
jpIRR3            mov PC, regval
                  jmp #cmd1
'......................................................................................................
srp               mov RP, nval                        'Registerpointer setzen
                  wrbyte RP, RP_adr
                  jmp #PCinc
'......................................................................................................
addc              andn FLAG, #%00001000 
                  jmp #subcc
'......................................................................................................                  
subc              or FLAG, #%00001000
subcc             wrbyte FLAG, flag_adr   
                  jmp #calc
'......................................................................................................                   
swap              shl val1, #8                                                                   
                  or val1, regval
                  mov val2, #4                  
                  jmp #calc
'......................................................................................................   
rlc               test FLAG,  #%1000_0000       wz    'Teste C-Flag                             
                  jmp #rl1
'......................................................................................................
rl                test val1, #%1000_0000        wz    'Teste bit7                                
rl1               muxnz val1, b31_mask                'schreibe nach bit31
                  jmp #calc1                                                                               
'......................................................................................................
rrc               test FLAG,  #%1000_0000       wz    'Teste C-Flag -> z                         
                  test val1, #%0000_0001        wc    'Teste bit0   -> c
                  jmp #rr1
'......................................................................................................
rr                test val1, #%0000_0001      wz, wc  'Teste bit0   -> z,c                        
rr1               muxnz val1, #$100                   'schreibe z nach bit8
                  muxc val1, b9_mask                  'schreibe c nach bit9
                  jmp #calc1
'......................................................................................................
sra               test val1, #%0000_0001        wc    'Teste bit0   -> c                         
                  test val1, #%1000_0000        wz    'Teste bit7
                  and FLAG, #%1110_1111 
                  jmp #rr1
'......................................................................................................          
com               test val1, #%1000_0000        wz    'Teste bit7                                 
                  muxnz val1, #$100                   'schreibe z nach bit8  
                  mov val2, #$ff
aox               and FLAG, #%1110_1111
                  jmp #calc
'......................................................................................................
tcm               mov hubadr, tcmx_adr
                  jmp #vm
'......................................................................................................            
ldc_ci            mov hubadr, ldcx_adr
                  jmp #vm
                                                                                                                                 
ldcci             mov temp, val1                                                                                                                            
ldcci_ma          call #pm_read                       'Lesen/Schreiben PM bzw. DM modifizierter Befehl!                                                                          
                  mov PC, tempval                     'PC zurckholen                                                                                       
                  mov regval, temp
                  jmp #dst_end
'......................................................................................................             
ldrX              mov hubadr, ldxx_adr
                  jmp #vm
'......................................................................................................                   
da                test  FLAG, #%0000_1000    wz       'D-Flag testen
         if_z     mov hubadr, daadd_adr
         if_nz    mov hubadr, dasub_adr
                  jmp #vm
                                
'---------------------------------------------------------------------------------------------------------

'*********************************************************************************************************
'* Common-Parts  
'*********************************************************************************************************
'......LMM-VM ............................................................................................              
vm               rdlong instr, hubadr
                 add hubadr, #4
instr            nop                                    
                 jmp #vm
'---------------------------------------------------------------------------------------------------------
inc_Irr          add regval, #1
set_Irr          ror regval, #8
                 call #set_REGval
                 rol regval, #8
                 add regnr, #1
                 call #set_REGval
inc_Irr_ret
set_Irr_ret      ret
'---------------------------------------------------------------------------------------------------------    
get_Irr          call #get_REGval2
Irr              mov tempval, regval
Irr2             shl tempval, #8
                 add regnr, #1
                 call #get_REGval2
                 or regval, tempval
get_Irr_ret
Irr2_ret
Irr_ret          ret
'---------------------------------------------------------------------------------------------------------
condit           mov hubadr, cond_adr
                 jmp #vm
                         
cond_end         cmp temp3, temp2          wz           'vergleichen
                 jmp #all_end
'---------------------------------------------------------------------------------------------------------
set_REGvalminus  sub regval, #1            
set_REGval       cmp regnr, #$F2           wz, wc
      if_c       jmp #RG_X               
      if_z       mov regnr, T1_wrnr 
                 cmp regnr, #$F4           wz   
      if_z       mov regnr, T0_wrnr
RG_X             mov z8reg_ptr, z8reg_adr 
                 add z8reg_ptr, regnr
                 wrbyte regval, z8reg_ptr
                 jmp #setreg_end
'---------------------------------------------------------------------------------------------------------
REGcmd           mov regnr, cmd_nr 
                 or regnr, RP  
                 jmp # abs_REG2
'.......................................................                 
r_right_x        mov nval, #0  
                 mov nval, arg1
                 add PC, #1
r_right_y        mov regnr, nval
r_right          and regnr, #$0F
                 jmp #rr2
r_left_x         mov regnr, nval
r_left           shr regnr, #4       
rr2              or regnr, RP '#$E0  
                 jmp #abs_REG3
'---------------------------------------------------------------------------------------------------------
rd_REG_x       
rd_n2            mov nval, #0
rd_n             shl nval, #8
rd_REG           add PC, #1
                 add arg_adr, #1
                 rdbyte temp, arg_adr  
                 or nval, temp  
                 tjz mode, #reg_end
                 sub mode, #1
                 mov regnr, temp
abs_REG          mov temp, regnr
                 and temp, #$F0
                 cmp temp, #$E0     wz
          if_z   and regnr, #$0F
          if_z   or  regnr, RP
abs_REG3         shl ival, #8
                 or ival, regnr
abs_REG2         tjz mode, #reg_end
                 sub mode, #1    
get_REGval       call #get_REGval2
                 tjz mode, #reg_end
                 mov regnr, regval
                 sub mode, #1
                 jmp #get_REGval
                  
reg_end          test sd_typ, #%0000_0100  wz
          if_nz  mov regval, nval 
                 test sd_typ, #%0000_0001  wz
          if_nz  mov dst_regnr, regnr
          if_nz  mov val1, regval
                 test sd_typ, #%0000_0010  wz
          if_nz  mov src_regnr, regnr
          if_nz  mov val2, regval 
                 mov mode, #0
                 mov sd_typ, #0
all_end         
setreg_end
condit_ret
get_REGval_ret
get_incREGval_ret
r_left_x_ret
r_left_ret
r_right_x_ret
r_right_y_ret
r_right_ret
REGcmd_ret
rd_n2_ret
rd_n_ret
rd_REG_x_ret
set_REGvalminus_ret
set_incREGval_ret
set_REGval_ret          
rd_REG_ret          
abs_REG_ret      jmp #0 'ret

'---------------------------------------------------------------------------------------------------------
get_REGval2      mov z8reg_ptr, z8reg_adr
                 add z8reg_ptr, regnr
                 rdbyte regval, z8reg_ptr
get_REGval2_ret  ret


'*********************************************************************************************************
'* Routinen Schreiben / Lesen vom Bus / Stack / Port2
'*********************************************************************************************************

'-----Stackoperationen------------------------------------------------------------------------------------
ret_flag          call #ST_R                       'vom Stack lesen
                  mov FLAG, regval                 'nach Flag schreiben
                  wrbyte FLAG,FLAG_adr
ST2PC             call #ST_R                       'vom Stack lesen  (H-Teil Adesse)
                  shl regval, #8                   'verschieben und
                  mov PC,regval                    'nach PC
                  call #ST_R                       'vom Stack lesen  (L-Teil Adresse)
                  or PC,regval                     'zu PC hinzufgen
                  jmp #set_SP
'--------------------------------------------------------------------------------------------------------- 
ST_read           call #ST_R
                  jmp #set_SP
'---------------------------------------------------------------------------------------------------------
PC2ST             mov regval, PC
                  call #ST_W
                  mov regval, PC
                  shr regval, #8
ST_write          call #ST_W
'.......................................................................
set_SP            wrbyte SP, SPL_adr  
                  mov temp, SP
                  shr temp, #8
                  wrbyte temp, SPH_adr
                
ret_flag_ret
ST2PC_ret                           
PC2ST_ret
ST_read_ret                    
ST_write_ret  
set_SP_ret        ret
'.........................................................................................................
ST_R              movi ch_ST_RW, #%000000_001           'Instruction-Code rdbyte 
                  call #STup2
                  add SP, #1
ST_R_ret          ret
'.........................................................................................................                  
ST_W              sub SP, #1
                  movi ch_ST_RW, #%000000_000           'Instruction-Code wrbyte 
STup2             mov adr_val, SP_adr
                  add adr_val, SP 
ch_ST_RW          wrbyte regval, adr_val
STup2_ret
ST_W_ret          ret

'*********************************************************************************************************                           
'-----Speicheroperationen---------------------------------------------------------------------------------
'*********************************************************************************************************
pm_write          movi ch_RW, #%000000_000           'Instruction-Code wrbyte
                  jmp #PM
pm_read           movi ch_RW, #%000000_001           'Instruction-Code rdbyte                
'.........................................................................................................
PM                mov adr_val, PC                    'Programmcounter einlesen
'.....ROM-Adressen........................................................................................
ROMadr            cmp PC, rom_e            wc        'Vgl. Adresse mit ROM-Ende
        if_nc     jmp #RAMadr                        'wenn grer zu RAM
                  add adr_val, rombaseadr            'phys. Adresse berechnen
                  rdbyte temp, adr_val               'Wert(Byte) von phys. Adresse im HUB einlesen 
                  jmp #go_end                        'und zurck
'.....RAM-Adressen........................................................................................        
RAMadr            cmpsub adr_val, ram_s    wc        '-> Offset fr phys. Adresse
        if_nc     jmp #KEYadr   
                  add adr_val, rambaseadr            'physische Adresse im HubRam errechnen  
'.....Speicher schreiben/lesen............................................................................
ch_RW             rdbyte temp, adr_val   
                  jmp #go_end
'.....Tastatur-Adressen...................................................................................   
KEYadr            cmp PC, key_e            wc        'vgl. mit Tastatur hchste Adresse
        if_c      cmp key_s, PC            wc        'wenn kleiner, dann vgl. mit niedrigster Adresse
        if_nc     mov temp, #$FF                     'kein Speicher 
        if_nc     jmp #go_end                        'wenn auerhalb des Bereiches dann Sprung, sonst
                  sub adr_val, key_s
                  add adr_val, keybaseadr
                  rdbyte temp, adr_val               'Wert(Byte) von phys. Adresse im HUB einlesen 
                  mov temp2, #$0
                  wrbyte temp2, adr_val              '0 nach phys. Adresse im HUB schreiben
'.........................................................................................................
go_end
RAMadr_ret
pm_read_ret
pm_write_ret      ret

'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************
 z8bus_adr     long  0
 z8bus_val     long  0 
 z8reg_adr     long  @REGx '0
 calc_adr      long  @REGx + def#calccmdreg '0
 reset_mask    long  %10000000_00000000_00000000_00000000
 INT_mask      long  %00100000_00000000_00000000_00000000
 adrdat_mask   long  %00000000_00000000_11111111_11111111
 cmd           long  0
 arg1          long  0
 arg2          long  0  
 dst_regnr     long  0
 src_regnr     long  0
 IRQ           long  0
 IMR           long  0
 RP            long  0   
 FLAG          long  0
 SP            long  0
 PC            long  0
 T0_wrnr       long   def#T0_wr
 T1_wrnr       long   def#T1_wr 
 ldxx_adr      long  @ldxx '0
 ldcx_adr      long  @ldcx '0 
 daadd_adr     long  @daadd '0
 dasub_adr     long  @dasub '0
 tcmx_adr      long  @tcmx '0
 grp_Fx_adr    long  @grp_Fx '0
 cond_adr      long  @cond '0
 x0_adr        long  @x0_jmp '0
 grp_jmp_adr   long  @grp_jmp '0 
 z8reg_ptr     long  0

 regnr         long  0
 regval        long  0
 v_16          long  $0000_8000
 z_16          long  $0000_FFFF
 b9_mask       long  %10_0000_0000
 b31_mask      long  %10000000_00000000_00000000_00000000
 rombaseadr    long  @ROMx
 rambaseadr    long  @RAMx
 keybaseadr    long  @KEYx
 rom_s         long   def#romstart       
 rom_e         long   def#romend          
 ram_s         long   def#ramstart        
 ram_e         long   def#ramend        
 key_s         long   def#keystart      
 key_e         long   def#keyend +1     
 dmem_s        long   def#dmemstart      
 dmem_e        long   def#dmemend
 flag_adr      long   def#FLAG
 IMR_adr       long   def#IMR
 RP_adr        long   def#RP
 SPH_adr       long   def#SPH
 SPL_adr       long   def#SPL
 IRQ_adr       long   def#IRQ

                                    
Mem            res   1
cpart1         res   1  
cpart2         res   1 
cpart3         res   1 
temp           res   1                                                 
temp2          res   1                                                 
temp3          res   1
tempval        res   1
flag_mask      res   1
nval           res   1
ival           res   1                                                 
val1           res   1                    
val2           res   1
adr            res   1
adr_val        res   1 
resultx        res   1                    
action         res   1                    
hubadr         res   1
cmd_grp        res   1
cmd_nr         res   1        
cmdjmp_adr     res   1
cmdhub_adr     res   1
'todo           res   1
cmdjmp         res   1
'grpjmp         res   1
mdsel1         res   1
'mdsel2         res   1
mode           res   1
sd_typ         res   1
arg_adr        res   1
SP_adr         res   1
'..............................
              
fit                                       
                                          